      SUBROUTINE CMWW( J, I1, I2, ZZM, NR, ZCW, NW, ITRP)
C     CMWW COMPUTES MATRIX ELEMENTS FOR WIRE-WIRE INTERACTIONS
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'data.inc'
      INCLUDE 'segj.inc'
      INCLUDE 'dataj.inc'
      COMMON  /ANGL/ SALP( NM)
      DIMENSION  ZZM( NR,1), ZCW( NW,1), CAB(NM), SAB(NM)
C     SET SOURCE SEGMENT PARAMETERS
      EQUIVALENCE(CAB,ALP),(SAB,BET)
      S= SI( J)
      B= BI( J)
      XJ= X( J)
      YJ= Y( J)
      RZJ= RXZ( J)
      CABJ= CAB( J)
      SABJ= SAB( J)
      SALPJ= SALP( J)
C     DECIDE WETHER EXT. T.W. APPROX. CAN BE USED
      IF( IEXK.EQ.0) GOTO 16
      IPR= ICON1( J)
      IF( IPR) 1,6,2
    1 IPR=- IPR
      IF(- ICON1( IPR).NE. J) GOTO 7
      GOTO 4
    2 IF( IPR.NE. J) GOTO 3
      IF( CABJ* CABJ+ SABJ* SABJ.GT.1.D-8) GOTO 7
      GOTO 5
    3 IF( ICON2( IPR).NE. J) GOTO 7
    4 XI= ABS( CABJ* CAB( IPR)+ SABJ* SAB( IPR)+ SALPJ* SALP( IPR))
      IF( XI.LT.0.999999D+0) GOTO 7
      IF( ABS( BI( IPR)/ B-1.).GT.1.D-6) GOTO 7
    5 IND1=0
      GOTO 8
    6 IND1=1
      GOTO 8
    7 IND1=2
    8 IPR= ICON2( J)
      IF( IPR) 9,14,10
    9 IPR=- IPR
      IF(- ICON2( IPR).NE. J) GOTO 15
      GOTO 12
   10 IF( IPR.NE. J) GOTO 11
      IF( CABJ* CABJ+ SABJ* SABJ.GT.1.D-8) GOTO 15
      GOTO 13
   11 IF( ICON1( IPR).NE. J) GOTO 15
   12 XI= ABS( CABJ* CAB( IPR)+ SABJ* SAB( IPR)+ SALPJ* SALP( IPR))
      IF( XI.LT.0.999999D+0) GOTO 15
      IF( ABS( BI( IPR)/ B-1.).GT.1.D-6) GOTO 15
   13 IND2=0
      GOTO 16
   14 IND2=1
      GOTO 16
   15 IND2=2
C
C     OBSERVATION LOOP
C
   16 CONTINUE

      IPR=0
      DO 23  I= I1, I2
      IPR= IPR+1
      IJ= I- J
      XI= X( I)
      YI= Y( I)
      UZI= RXZ( I)
      AI= BI( I)
      CABI= CAB( I)
      SABI= SAB( I)
      SALPI= SALP( I)
      CALL EFLD( XI, YI,UZI, AI, IJ)

      ZETK= ZEXK* CABI+ ZEYK* SABI+ ZEZK* SALPI
      ZETS= ZEXS* CABI+ ZEYS* SABI+ ZEZS* SALPI
C
C     FILL MATRIX ELEMENTS.  ELEMENT LOCATIONS DETERMINED BY CONNECTION
C     DATA.
C
      ZETC= ZEXC* CABI+ ZEYC* SABI+ ZEZC* SALPI
C     NORMAL FILL
      IF( ITRP.NE.0) GOTO 18
      DO 17  IJ=1, JSNO
      JX= JCO( IJ)

   17 ZZM(IPR,JX)=ZZM(IPR,JX)+ZETK*AX(IJ)+ZETS*BX(IJ)+ZETC*CX(IJ)

      GOTO 23
C     TRANSPOSED FILL
   18 IF( ITRP.EQ.2) GOTO 20
      DO 19  IJ=1, JSNO
      JX= JCO( IJ)
   19 ZZM(JX,IPR)=ZZM(JX,IPR)+ZETK*AX(IJ)+ZETS*BX(IJ)+ZETC*CX(IJ)
C     TRANS. FILL FOR C(WW) - TEST FOR ELEMENTS FOR D(WW)PRIME.  (=CW)
      GOTO 23
   20 DO 22  IJ=1, JSNO
      JX= JCO( IJ)
      IF( JX.GT. NR) GOTO 21
      ZZM(JX,IPR)=ZZM(JX,IPR)+ZETK*AX(IJ)+ZETS*BX(IJ)+ZETC*CX(IJ)
      GOTO 22
   21 JX= JX- NR
      ZCW(JX,IPR)=ZCW(JX,IPR)+ZETK*AX(IJ)+ZETS*BX(IJ)+ZETC*CX(IJ)
   22 CONTINUE


   23 CONTINUE
      RETURN
      END
