      SUBROUTINE CONECT
C     CONNECT SETS UP SEGMENT CONNECTION DATA IN ARRAYS ICON1 AND ICON2
C     BY SEARCHING FOR SEGMENT ENDS THAT ARE IN CONTACT.
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'data.inc'
      INCLUDE 'segj.inc'
      INCLUDE 'cntrl.inc'
      DIMENSION  X2(NM), Y2(NM), XZ2(NM)
      EQUIVALENCE(X2,SI),(Y2,ALP),(XZ2,BET)
      DATA   SMIN/1.D-3/
C    3 IF( N.EQ.0) GOTO 26
      DO 15  I=1, N
      ICONX( I)=0
      XI1= X( I)
      YI1= Y( I)
      UZI1= RXZ( I)
      XI2= X2( I)
      YI2= Y2( I)
      UZI2= XZ2( I)
C
C     DETERMINE CONNECTION DATA FOR END 1 OF SEGMENT.
C
      SLEN= SQRT((XI2-XI1)**2+(YI2-YI1)**2+( UZI2- UZI1)**2)* SMIN
    5 IC= I
      DO 7  J=2, N
      IC= IC+1
      IF( IC.GT. N) IC=1
      SEP= ABS( XI1- X( IC))+ ABS( YI1-Y(IC))+ABS(UZI1-RXZ( IC))
      IF( SEP.GT. SLEN) GOTO 6
      ICON1( I)=- IC
      GOTO 8
    6 SEP=ABS(XI1-X2(IC))+ABS(YI1-Y2(IC))+ ABS( UZI1- XZ2( IC))
      IF( SEP.GT. SLEN) GOTO 7
      ICON1( I)= IC
      GOTO 8
    7 CONTINUE
C
C     DETERMINE CONNECTION DATA FOR END 2 OF SEGMENT.
C
      ICON1( I)=0
    8 CONTINUE
   12 IC= I
      DO 14  J=2, N
      IC= IC+1
      IF( IC.GT. N) IC=1
      SEP= ABS(XI2-X(IC))+ABS(YI2- Y( IC))+ ABS( UZI2- RXZ( IC))
      IF( SEP.GT. SLEN) GOTO 13
      ICON2( I)= IC
      GOTO 15
   13 SEP= ABS(XI2-X2(IC))+ABS( YI2- Y2( IC))+ ABS( UZI2- XZ2( IC))
      IF( SEP.GT. SLEN) GOTO 14
      ICON2( I)=- IC
      GOTO 15
   14 CONTINUE
      ICON2( I)=0
   15 CONTINUE
C     FIND WIRE-SURFACE CONNECTIONS FOR NEW PATCHES
      ISEG=N/NP
      IF( ISEG.EQ.1) GOTO 30
      IF( IPSYM) 30,27,29
   27 STOP
   29 IC= ISEG/2
      IF( ISEG.EQ.8) IC=3
   30 CONTINUE
C     ADJUST CONNECTED SEG. ENDS TO EXACTLY COINCIDE.  PRINT JUNCTIONS
C     OF 3 OR MORE SEG.  ALSO FIND OLD SEG. CONNECTING TO NEW SEG.
      ISEG=0
      DO 44  J=1, N
      IEND=-1
      JEND=-1
      IX= ICON1( J)
      IC=1
      JCO(1)=- J
      XA= X( J)
      YA= Y( J)
      UZA= RXZ( J)
   31 IF( IX.EQ.0) GOTO 43
      IF( IX.EQ. J) GOTO 43
      IF( IX.GT.10000) GOTO 43
      NSFLG=0
   32 IF( IX) 33,49,34
   33 IX=- IX
      GOTO 35
   34 JEND=- JEND
   35 IF( IX.EQ. J) GOTO 37
      IF( IX.LT. J) GOTO 43
      IC= IC+1
      IF( IC.GT. JMAX) GOTO 49
      JCO( IC)= IX* JEND
      NSFLG=1
      IF( JEND.EQ.1) GOTO 36
      XA= XA+ X( IX)
      YA= YA+ Y( IX)
      UZA= UZA+ RXZ( IX)
      IX= ICON1( IX)
      GOTO 32
   36 XA= XA+ X2( IX)
      YA= YA+ Y2( IX)
      UZA= UZA+ XZ2( IX)
      IX= ICON2( IX)
      GOTO 32
   37 SEP= IC
      XA= XA/ SEP
      YA= YA/ SEP
      UZA= UZA/ SEP
      DO 39  I=1, IC
      IX= JCO( I)
      IF( IX.GT.0) GOTO 38
      IX=- IX
      X( IX)= XA
      Y( IX)= YA
      RXZ( IX)= UZA
      GOTO 39
   38 X2( IX)= XA
      Y2( IX)= YA
      XZ2( IX)= UZA
   39 CONTINUE
   42 IF( IC.LT.3) GOTO 43
      ISEG= ISEG+1
   43 IF( IEND.EQ.1) GOTO 44
      IEND=1
      JEND=1
      IX= ICON2( J)
      IC=1
      JCO(1)= J
      XA= X2( J)
      YA= Y2( J)
      UZA= XZ2( J)
      GOTO 31
   44 CONTINUE
      RETURN
   49 WRITE(*,53)  IX
   53 FORMAT(' CONNECT - SEGMENT CONNECTION ERROR FOR SEGMENT',I5)
      WRITE(*,*)'TOO MANY SEGMENTS AT ONE POINT'
      STOP
      END
