      SUBROUTINE WIRE(XW1,YW1,XZW1,XW2,YW2,XZW2,RAD,NS,ITG)
C ***
C     SUBROUTINE WIRE GENERATES SEGMENT GEOMETRY DATA FOR A STRAIGHT
C     WIRE OF NS SEGMENTS.
C
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'data.inc'
      DIMENSION  X2(NM),Y2(NM),XZ2(NM)
      EQUIVALENCE(X2(1),SI(1)),(Y2(1),ALP(1)),(XZ2(1),BET(1))
      IST= N+1
      N= N+ NS
      IF(N.GT.NM)GOTO 944
      NP= N
      IPSYM=0
      IF( NS.LT.1) RETURN
      XD=(XW2-XW1)/NS
      YD=(YW2-YW1)/NS
      UZD=(XZW2-XZW1)/NS
      IF(IRADCO.EQ.0)GOTO 2002
      RADWL=RAD*GSVAL/WLAM
      if(iradco.ne.9.and.(RADWL.LT..001.OR.RADWL.GT..003))GOTO 2007
      SLEN=SQRT(XD**2+YD**2+UZD**2)
      RADZ= RAD*( 0.94 + 2.7 * SLEN*GSVAL/WLAM)
      GOTO 2003
 2007 WRITE(*,*)'Element radius outside range for modified NEC'
      WRITE(*,*)'Use original NEC  -  Option MO  0 in PARNR.NEC'
      STOP
 2002 RADZ=RAD
 2003 XS1= XW1
      YS1= YW1
      UZS1= XZW1
      DO 3  I= IST, N
      ITAG( I)= ITG
      XS2= XS1+XD
      YS2= YS1+YD
      UZS2= UZS1+UZD
      X( I)= XS1
      Y( I)= YS1
      RXZ( I)= UZS1
      X2( I)= XS2
      Y2( I)= YS2
      XZ2( I)= UZS2
      BI( I)= RADZ
      BI0(I)=RAD
      XS1= XS2
      YS1= YS2
    3 UZS1= UZS2
      X2( N)= XW2
      Y2( N)= YW2
      XZ2( N)= XZW2
      RETURN
 944  WRITE(*,*)'WIRE: Too many segments N',N,NM
      END
