      SUBROUTINE CABC( CURX)
C     CABC COMPUTES COEFFICIENTS OF THE CONSTANT (A), SINE (B), AND
C     COSINE (C) TERMS IN THE CURRENT INTERPOLATION FUNCTIONS FOR THE
C     CURRENT VECTOR CUR.
C
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      COMPLEX*16 CURX, CURD, CCJ
      INCLUDE 'data.inc'
      INCLUDE 'crnt.inc'
      INCLUDE 'segj.inc'
      INCLUDE 'vsorc.inc'
      COMMON  /ANGL/ SALP( NM)
      DIMENSION  T1X(1), T1Y(1), T1Z(1), T2X(1), T2Y(1), T2Z(1)
      DIMENSION  CURX(1), CCJX(2), XTM(2)
      EQUIVALENCE(T1X,SI),(T1Y,ALP),(T1Z,BET),(T2X,ICON1),(T2Y,ICON2),(
     &T2Z,ITAG),(ZTM,XTM(1))
      EQUIVALENCE(CCJ,CCJX)
      DATA   PI/3.141592653589793D0/
      DATA   CCJX/0.,-0.01666666667D+0/
      TP=2*PI
      DO 1  I=1, N
      AIR( I)=0.
      AII( I)=0.
      BIR( I)=0.
      BII( I)=0.
      CIR( I)=0.
    1 CII( I)=0.
      DO 2  I=1, N
      ZTM=CURX(I)
      AR= XTM(1)
      AI= XTM(2)
      CALL TBF( I,1)
      DO 2  JX=1, JSNO
      J= JCO( JX)
      AIR( J)= AIR( J)+ AX( JX)* AR
      AII( J)= AII( J)+ AX( JX)* AI
      BIR( J)= BIR( J)+ BX( JX)* AR
      BII( J)= BII( J)+ BX( JX)* AI
      CIR( J)= CIR( J)+ CX( JX)* AR
    2 CII( J)= CII( J)+ CX( JX)* AI
      IF( NQDS.EQ.0) GOTO 4
      DO 3  IS=1, NQDS
      I= IQDS( IS)
      JX= ICON1( I)
      ICON1( I)=0
      CALL TBF( I,0)
      ICON1( I)= JX
      SH= SI( I)*.5
      CURD= CCJ* ZVQDS(IS)/((LOG(2.*SH/ BI( I))-1.)*( BX( JSNO)* COS(
     & TP* SH)+ CX( JSNO)* SIN( TP* SH))* WLAM)
      ZTM=CURD
      AR= XTM(1)
      AI= XTM(2)
      DO 3  JX=1, JSNO
      J= JCO( JX)
      AIR( J)= AIR( J)+ AX( JX)* AR
      AII( J)= AII( J)+ AX( JX)* AI
      BIR( J)= BIR( J)+ BX( JX)* AR
      BII( J)= BII( J)+ BX( JX)* AI
      CIR( J)= CIR( J)+ CX( JX)* AR
    3 CII( J)= CII( J)+ CX( JX)* AI
    4 DO 5  I=1, N
    5 CURX( I)= CMPLX( AIR( I)+ CIR( I), AII( I)+ CII( I))
      RETURN
      END
